Index: palm/trunk/SOURCE/data_output_2d.f90
===================================================================
--- palm/trunk/SOURCE/data_output_2d.f90	(revision 4901)
+++ palm/trunk/SOURCE/data_output_2d.f90	(revision 1)
@@ -1211,13 +521,9 @@
                 ELSEIF ( grid == 'zw' )  THEN
                    IF ( mode == 'xy' )  level_z = zw
-                ELSEIF ( grid == 'zu1' ) THEN
-                   IF ( mode == 'xy' )  level_z(nzb+1) = zu(nzb+1)
-                ELSEIF ( grid == 'zs' ) THEN
-                   IF ( mode == 'xy' )  level_z = zs
                 ENDIF
 
                 IF ( .NOT. found )  THEN
-                   message_string = 'no output provided for: ' // TRIM( do2d(av,ivar) )
-                   CALL message( 'data_output_2d', 'PA0181', 0, 0, 0, 6, 0 )
+                   PRINT*, '+++ data_output_2d: no output provided for: ', &
+                                do2d(av,if)
                 ENDIF
 
@@ -1225,13 +531,10 @@
 
 !
-!--       Resort the array to be output, if not done above. Flag topography grid points with fill
-!--       values, using the corresponding maksing flag.
+!--       Resort the array to be output, if not done above
           IF ( .NOT. resorted )  THEN
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   DO  k = nzb_do, nzt_do
-                      local_pf(i,j,k) = MERGE( to_be_resorted(k,j,i),                              &
-                                               REAL( fill_value, KIND = wp ),                      &
-                                               BTEST( wall_flags_total_0(k,j,i), flag_nr ) )
+             DO  i = nxl-1, nxr+1
+                DO  j = nys-1, nyn+1
+                   DO  k = nzb, nzt+1
+                      local_pf(i,j,k) = to_be_resorted(k,j,i)
                    ENDDO
                 ENDDO
@@ -1240,7 +543,8 @@
 
 !
-!--       Output of the individual cross-sections, depending on the cross-section mode chosen.
+!--       Output of the individual cross-sections, depending on the cross- 
+!--       section mode chosen.
           is = 1
-   loop1: DO WHILE ( section(is,s_ind) /= -9999  .OR.  two_d )
+   loop1: DO  WHILE ( section(is,s) /= -9999  .OR.  two_d )
 
              SELECT CASE ( mode )
@@ -1252,28 +556,24 @@
                       layer_xy = nzb+1
                    ELSE
-                      layer_xy = section(is,s_ind)
-                   ENDIF
-
-!
-!--                Exit the loop for layers beyond the data output domain (used for soil model)
-                   IF ( layer_xy > nzt_do )  THEN
-                      EXIT loop1
-                   ENDIF
-
-!
-!--                Update the netCDF xy cross section time axis.
-!--                In case of parallel output, this is only done by PE0 to increase the performance.
-                   IF ( time_since_reference_point /= do2d_xy_last_time(av) )  THEN
-                      do2d_xy_time_count(av) = do2d_xy_time_count(av) + 1
-                      do2d_xy_last_time(av)  = time_since_reference_point
-                      IF ( myid == 0 )  THEN
-                         IF ( .NOT. data_output_2d_on_each_pe  .OR.  netcdf_data_format > 4 )  THEN
-#if defined( __netcdf )
-                            nc_stat = NF90_PUT_VAR( id_set_xy(av),                                 &
-                                                    id_var_time_xy(av),                            &
-                                                    (/ time_since_reference_point /),              &
-                                                    start = (/ do2d_xy_time_count(av) /),          &
+                      layer_xy = section(is,s)
+                   ENDIF
+
+!
+!--                Update the NetCDF xy cross section time axis
+                   IF ( myid == 0 )  THEN
+                      IF ( simulated_time /= do2d_xy_last_time(av) )  THEN
+                         do2d_xy_time_count(av) = do2d_xy_time_count(av) + 1
+                         do2d_xy_last_time(av)  = simulated_time
+                         IF ( .NOT. data_output_2d_on_each_pe  .AND. &
+                              netcdf_output )  THEN
+#if defined( __netcdf )
+                            nc_stat = NF90_PUT_VAR( id_set_xy(av),             &
+                                                    id_var_time_xy(av),        &
+                                                    (/ simulated_time /),      &
+                                         start = (/ do2d_xy_time_count(av) /), &
                                                     count = (/ 1 /) )
-                            CALL netcdf_handle_error( 'data_output_2d', 53 )
+                            IF ( nc_stat /= NF90_NOERR )  THEN
+                               CALL handle_netcdf_error( 53 )
+                            ENDIF
 #endif
                          ENDIF
@@ -1282,12 +582,12 @@
 !
 !--                If required, carry out averaging along z
-                   IF ( section(is,s_ind) == -1  .AND.  .NOT. two_d )  THEN
-
-                      local_2d = 0.0_wp
+                   IF ( section(is,s) == -1 )  THEN
+
+                      local_2d = 0.0
 !
 !--                   Carry out the averaging (all data are on the PE)
-                      DO  k = nzb_do, nzt_do
-                         DO  j = nys, nyn
-                            DO  i = nxl, nxr
+                      DO  k = nzb, nzt+1
+                         DO  j = nys-1, nyn+1
+                            DO  i = nxl-1, nxr+1
                                local_2d(i,j) = local_2d(i,j) + local_pf(i,j,k)
                             ENDDO
@@ -1295,5 +595,5 @@
                       ENDDO
 
-                      local_2d = local_2d / ( nzt_do - nzb_do + 1.0_wp)
+                      local_2d = local_2d / ( nzt -nzb + 2.0 )
 
                    ELSE
